//#define MIDI_OFF

//allows CC commands to be sent if knob changes more than 7 values (bottom 3 bits change)
#define SENDMIDICC

//allows CC commands to be received
#define RECMIDICC


//enables three trigger inputs on a sixth 74HC165 chip off the EXPAND header
//#define TRIGGERSENABLED


//enables a long play/pause cycle
//time is in milliseconds
//6000 = 6 seconds
//12000 = 12 secods
//600000 = 10 minutes
//1200000 = 20 minutes

#define ON_OFF_CYCLE_ENABLED
#define ON_CYCLE_TIME 600000
#define OFF_CYCLE_TIME 1200000



//enables MOMENTMODE switch on PA2
#define ENABLEMOMENTMODE



			#define JOYTOY_orange 1
			#define JOYTOY_surf 2
			#define JOYTOY_saki 3
			#define AH232 0
			#define JOYTOY_ghost 4
  

#define MATRIX_VERSION AH232


#if (MATRIX_VERSION==JOYTOY_saki)

 #define ALWAYS_FLASH_TEMPO 0
 //#define GREEN_IS_BEATS
 #ifndef ENABLEMOMENTMODE
 	#define ENABLEMOMENTMODE
 #endif

#elif (MATRIX_VERSION==JOYTOY_orange)
 #define ALWAYS_FLASH_TEMPO 1
 #define ONE_PER_ROW_GREEN
 #ifndef ENABLEMOMENTMODE
 	#define ENABLEMOMENTMODE
 #endif



#else
 #define ALWAYS_FLASH_TEMPO 0
#endif




//this should only be uncommented if we are using a MEGA32A and internal 8MHz RC oscillator,
//which is not accurate and needs "correction" by using a different UBBR value.
//Best practice is to use external resonantor at 8MHz
//#define using_ATMEGA32A_and_internal8MHzRCclock


//a very special-case setting, used for Jared Dunne's Bend Matrix
//#define MAP_CCS_TO_BUTTONS


/************ END USER SET PARAMS ******************/



//	pcb v2.1 and up should define REVERSEDKNOBS (where AIN0/1 are swapped with AIN2/3)
#define REVERSEDKNOBS

//	8MHz should define slowMHZ:
#define slowMHZ


/*	MZ is Matrix siZe */
//	4x8 button matrix, v2.1 and later:
#define MZ 2
//	2x8 button matrix, v2.0:
//#define MZ 1



/*
	READDUALMATRIXMODE==1 is dual 2x4 or dual 4x4.
	READDUALMATRIXMODE==0 is 2x8 or 4x8

*/
#define READDUALMATRIXMODE (PINA & (1<<3))


/*
	DISPLAYHOLD is the number of cycles to keep a value on the 7 SEG LED display
	before returning to the SPIN animation in play mode
*/
#ifndef slowMHZ
#define DISPLAYHOLD 300
#define FLASHTIME 12
#else
#define DISPLAYHOLD 150
#define FLASHTIME 6
#endif

/*
	Input Shift Register (74HC165)
	CP=clock pulse (L->H)
	PL=load (low)/shift (high)
*/
#define SR PORTD
#define SR_ddr DDRD
#define SR_CP 5
#define SR_PL 4
#define SR_serial (PIND & (1<<6))

/*
	Output Shift Register (74HC595)
	ST=Latch
	SH=shift
	DS=data
*/
#define OSR PORTC
#define OSR_ddr DDRC
#define OSR_ST 6
#define OSR_SH 7
#define OSR_DS 5

/*
	Control buttons
*/
#ifdef ENABLEMOMENTMODE
	#define MOMENTMODE (PINA & (1<<2))
#else
	#define MOMENTMODE 0
#endif

#define SHIFT (PINA & (1<<3))
#define CLEAR (PINC & (1<<4))
#define PLAYSAVE_ddr DDRC
#define PLAYSAVECLEARBUTTONS ((1<<0) | (1<<2) | (1<<4))
#define PLAY (PINC & (1<<2))
#define SAVE (PINC & (1<<0))
#define PLAYSAVE_LED PORTC
#define SAVE_LED 1
#define PLAY_LED 3

/*
	MIDI
*/
#define MIDI_CHANNEL 0
#define NOTEON 0x90
#define NOTEOFF 0x80
#define MIDI_com_CC 0xB0
#define BPM_START_MIDI 0xFA
#define BPM_STOP_MIDI 0xFB
#define BPM_CLOCK_MIDI 0xF8

#ifdef slowMHZ
	#ifdef using_ATMEGA32A_and_internal8MHzRCclock
		#define	MIDIUBBR 16
	#else
		#define MIDIUBBR 15
	#endif
#else
#define	MIDIUBBR 31	
#endif



/*
	Knob Mode buttons (SHIFT+seq)
*/
#define STROBE_MODE 0
#define ARP_MODE 1
#define GLOOB_MODE 2
#define RANDOM_MODE 3
#define KNOBLAYOUT_MODE 4
#define MIDI_MODE 5
#define LENGTH_MODE 6
#define PATH_MODE 7


/*
	BPM rotary encoder and Tempo LED
*/
#define TEMPO PIND
#define TEMPO_ddr DDRD
#define UP 2
#define DOWN 3
#define TEMPO_LED 7
#define TEMPO_LED_PORT PORTD


/*
	MT8816 16x8 cross-point switch IC
*/
#define SWITCH PORTB
#define SWITCH_ddr DDRB
#define SW_STROBE PB0
#define SW_DATA PB1
#define SW_AY0 PB2
#define SW_AY1 PB3
#define SW_AY2 PB5
#define SW_AX0 PB4
#define SW_AX1 PB7
#define SW_RESET PB6
//switch hi-address pins
#define SWITCH_HI PORTA
#define SWITCH_HI_ddr DDRA
#define SW_AX2 PA6
#define SW_AX3 PA7


/*
	Analog inputs
	AIN# specifies pin number on Port A
*/
#ifndef REVERSEDKNOBS
#define AIN0 0
#define AIN1 1
#define AIN2 4
#define AIN3 5
#else
#define AIN0 4
#define AIN1 5
#define AIN2 0
#define AIN3 1
#endif

#define EEPROM_GLOBALS_ADDR 512
#define EEPROM_BPM_ADDR 528

//33 bytes?
#define EEPROM_LENGTH_ADDR 550

#define EEPROM_MIDI_NOTE_ASSIGN_ADDR 700
#define EEPROM_MIDI_CC_ASSIGN_ADDR 732
#define EEPROM_MIDI_CCBUTTON_ASSIGN_ADDR 736

inline short BIT(short bit);
uint16_t get_use_bpm(void);
void get_nextstep(uint8_t *nextbank, uint8_t *nextcur);
void get_prevstep(uint8_t *prevbank, uint8_t *prevcur);

