#include <stdarg.h>
#include <ctype.h>
#include <avr/io.h>
#include <avr/interrupt.h>

#include "bendmatrix2.h"
#include "globals.h"
#include "timer.h"

volatile long tmrms;


SIGNAL (SIG_OVERFLOW0){
	tmrms+=MINTIME;
	TCNT0=TMROFFSET; // Re-init timer
}


long gettmrms(void){
	long result;
	cli();
	result = tmrms;
	sei();
	return result;
}

int inttimerreached(int *nexttime,unsigned int period){
// Up to 30000 msec / 30 sec
	char result;
	int itmrms;
	int tmrdiff;

	itmrms=(int) gettmrms();
	if (*nexttime==0) *nexttime=itmrms+period;
	tmrdiff=itmrms - *nexttime;
	if (tmrdiff<0)
	{
		result = 0;
	}
	else
	{
		*nexttime = itmrms+period;
		if (*nexttime==0) *nexttime++; // Nexttime cannot be 0 again
		if (tmrdiff==0) result=1;
		else result = tmrdiff;
	}
	return result;
}

void wait(int period){
	int waittimer;
	waittimer = 0;
	while (!inttimerreached(&waittimer,period));
}

void inittimer(void){
	TCCR1A=0x00;
	TCCR1B=0x01;
	TCNT1=0x00;
	
	TCCR0=0x03;			// Prescaler CK/64
	TCNT0=TMROFFSET;
	TIMSK=BIT(0); 		// Enable bytetimer interrupt
	sei();
}
